//+------------------------------------------------------------------+
//|                                                     II_Trend_mq4 |
//|                            Copyright  2009, Insanity Industries |
//|                                http://www_insanityindustries_net |
//| v1.0 02/9/10
//+------------------------------------------------------------------+
#property copyright "Copyright  2009, Insanity Industries"
#property link      "http://www.insanityindustries.net"

#property indicator_chart_window

extern int tf = 0;
extern int object_layer = 15;
extern int HUD_corner = 1;
extern int pos_x = 30;
extern int pos_y = 30;
extern color color_border = White;
extern color color_cell = MediumBlue;
extern color color_up = LimeGreen;
extern color color_dn = Red;
extern color color_up_s = DarkGreen;
extern color color_dn_s = Maroon;
extern color color_hd = 0x10d0d0;
extern color color_hs = 0x107070;

string font = "Pieces of Eight";
string arrow_up,arrow_dn;
string TAG;
int fs_header = 20;
int fs_main = 50;
int fs_cur = 30;

bool MT,ST;
string pair;
int ctf;
int mtf;

string dir[2];
color mc,cc,mcs,ccs;

datetime ls,ss;

string l_hud,l_c;

int hud_t_x,hud_ts_x,hud_t_y,hud_ts_y,hud_ma_x,hud_ma_y,hud_mas_x,hud_mas_y,hud_ca_x,hud_ca_y,hud_cas_x,hud_cas_y;
int hud_c_x,hud_c_y,hud_b_x,hud_b_y;

int init(){
   if(object_layer > 25) object_layer = 25;
   l_hud = CharToStr(0x61+object_layer);
   l_c = CharToStr(0x61+object_layer-1);
   if(tf==0) mtf = Period();
      else mtf = tf;
   TAG = "II_Trend";
   Comment("");
   arrow_up = CharToStr(241);
   arrow_dn = CharToStr(242);
   
   pair = Symbol();
   getSTF(mtf);
   ls=0;
   ss=0;
   setHUD();
   DoLogo();
   return(0);
}

int deinit(){
   ObDeleteObjectsByPrefix(l_hud+TAG);
   ObDeleteObjectsByPrefix(l_c+TAG);
   Comment("");
   return(0);
}

int start(){
   if(ls < iTime(pair,mtf,0)){
      MT = getMainTrend(mtf);
      ls = iTime(pair,mtf,0);
   }
   if(ss < iTime(pair,ctf,0)){
      ST = getNowTrend(MT,mtf,ctf);
      ls = iTime(pair,ctf,0);
   }

   draw(MT,ST);
   return(0);
}

bool getNowTrend(bool t, int ltf, int stf){
   bool lb;
   lb = iOpen(pair,ltf,1) < iClose(pair,ltf,1);
   if (t != lb){
      if(t){
         if (iClose(pair,stf,1) < iLow(pair,ltf,1)) return(!t);
         return(t);
      } else {
         if (iClose(pair,stf,1) > iHigh(pair,ltf,1)) return(!t);
         else return(t);
      }
   } else return(t);
}

bool getMainTrend(int ltf){
   bool lb,cb,co;
   lb = iOpen(pair,ltf,1) < iClose(pair,ltf,1);
   for(int i=2;i<iBars(pair,ltf);i++){

      if(lb) co = iClose(pair,ltf,i-1) > iHigh(pair,ltf,i);
         else co = iClose(pair,ltf,i-1) < iLow(pair,ltf,i);

      cb = iOpen(pair,ltf,i) < iClose(pair,ltf,i);

      if (cb == lb && co==true) {
         return(cb);
         break;
      }
      lb = cb;
   }
}

void getSTF(int ltf){
   switch(ltf){
      case PERIOD_M5 :  ctf = PERIOD_M1;
                        break;
      case PERIOD_M15 : ctf = PERIOD_M5;
                        break;
      case PERIOD_M30 : ctf = PERIOD_M5;
                        break;
      case PERIOD_H1 :  ctf = PERIOD_M15;
                        break;
      case PERIOD_H4 :  ctf = PERIOD_M30;
                        break;
      case PERIOD_D1 :  ctf = PERIOD_H4;
                        break;
      case PERIOD_W1 :  ctf = PERIOD_D1;
                        break;
      case PERIOD_MN1 : ctf = PERIOD_W1;
                        break;
      default : Comment("Get Your TimeFrame Right!");
   }
}

void DrawCell(int nWindow, string nCellName, double nX, double nY, double nWidth, double nHeight, color nColor, int cnr){ //Code from MT4 codebase
   double iHeight, iWidth, iXSpace;
   int iSquares, i;
   if(nWidth > nHeight){
     iSquares = MathCeil(nWidth/nHeight);      // Number of squares used_
     iHeight = MathRound((nHeight*100)/77);   // Real height size_
     iWidth = MathRound((nWidth*100)/77);    // Real width size_
     iXSpace = iWidth/iSquares - ((iHeight/(9-(nHeight/100)))*2);
      for(i=0;i<iSquares;i++){
         ObjectCreate(nCellName+i, OBJ_LABEL,nWindow,0,0);
         ObjectSetText(nCellName+i, CharToStr(110),iHeight, "Wingdings", nColor);
         ObjectSet(nCellName+i, OBJPROP_XDISTANCE,nX + iXSpace*i);
         ObjectSet(nCellName+i, OBJPROP_YDISTANCE,nY);    
         ObjectSet(nCellName+i, OBJPROP_BACK, false);
         ObjectSet(nCellName+i, OBJPROP_CORNER, cnr);
      }        
   }else{
      iSquares = MathCeil(nHeight/nWidth);      // Number of squares used_
      iHeight  = MathRound((nHeight*100)/77);   // Real height size_
      iWidth   = MathRound((nWidth*100)/77);    // Real width size_
      iXSpace  = iHeight/iSquares - ((iWidth/(9-(nWidth/100)))*2);
      for(i=0;i<iSquares;i++){
         ObjectCreate   (nCellName+i, OBJ_LABEL,nWindow,0,0);
         ObjectSetText  (nCellName+i, CharToStr(110),iWidth, "Wingdings", nColor);
         ObjectSet      (nCellName+i, OBJPROP_XDISTANCE,nX);
         ObjectSet      (nCellName+i, OBJPROP_YDISTANCE,nY + iXSpace*i);    
         ObjectSet      (nCellName+i, OBJPROP_BACK, false);
         ObjectSet      (nCellName+i, OBJPROP_CORNER, cnr);
      }       
   }
}

void DoLogo(){
   string TAG = CharToStr(0x61+27)+"II_Logo";
   if( ObjectFind(TAG+"ZZ"+0) >= 0 && ObjectFind(TAG+"ZZ"+1) >= 0 && ObjectFind(TAG+"ZZ"+2) >= 0  && 
       ObjectFind(TAG+"AZ"+0) >= 0 && ObjectFind(TAG+"AZ"+1) >= 0 && ObjectFind(TAG+"AZ"+2) >= 0 ) return;
   string str[3] = {"$","Insanity","Industries"};
   int size[3] = {25,10,10};
   int pos_x[3] = {47,19,17};
   int pos_y[3] = {10,25,15};
   int pos_xs[3] = {46,18,16};
   int pos_ys[3] = {9,24,14};
   for(int i=0;i<3;i++){
      string n = TAG+"ZZ"+i;
      ObjectDelete(n);
      ObjectCreate(n,OBJ_LABEL,0,0,0);
      ObjectSetText(n,str[i],size[i],"Pieces Of Eight",AliceBlue);
      ObjectSet(n,OBJPROP_XDISTANCE,pos_x[i]);
      ObjectSet(n,OBJPROP_YDISTANCE,pos_y[i]);
      ObjectSet(n,OBJPROP_CORNER,3);
      n = TAG+"AZ"+i;
      ObjectDelete(n);
      ObjectCreate(n,OBJ_LABEL,0,0,0);
      ObjectSetText(n,str[i],size[i],"Pieces Of Eight",Black);
      ObjectSet(n,OBJPROP_XDISTANCE,pos_xs[i]);
      ObjectSet(n,OBJPROP_YDISTANCE,pos_ys[i]);
      ObjectSet(n,OBJPROP_CORNER,3);
   }
}

void DrawText(string l, string t, int x, int y, color c, string f, int s, int k=0, int a=0, bool b=false)
{
   string tag = l_hud+TAG+l+x+y;
   ObjectDelete(tag);
   ObjectCreate(tag,OBJ_LABEL,0,0,0);
   ObjectSetText(tag,t,s,f,c);
   ObjectSet(tag,OBJPROP_XDISTANCE,x);
   ObjectSet(tag,OBJPROP_YDISTANCE,y);
   ObjectSet(tag,OBJPROP_CORNER,k);
   ObjectSet(tag,OBJPROP_ANGLE,a);
   if(b) ObjectSet(tag,OBJPROP_BACK,true);
}

void ObDeleteObjectsByPrefix(string Prefix){ //code by TRO
   int L = StringLen(Prefix);
   int i = 0; 
   while(i < ObjectsTotal()) {
      string ObjName = ObjectName(i);
      if(StringSubstr(ObjName, 0, L) != Prefix) {
         i++;
         continue;
      }
      ObjectDelete(ObjName);
   }
}


void setHUD()
{
   if(HUD_corner > 3) HUD_corner=0;
   switch(HUD_corner){
      case 0 : hud_t_x = pos_x+4;
               hud_t_y = pos_y+3;
               hud_ts_x = hud_t_x+1;
               hud_ts_y = hud_t_y+1;
               hud_ma_x = hud_t_x+7;
               hud_ma_y = hud_t_y+20;
               hud_mas_x = hud_ma_x+1;
               hud_mas_y = hud_ma_y+1;
               hud_ca_x = hud_ma_x+41;
               hud_ca_y = hud_ma_y+13;
               hud_cas_x = hud_ca_x+1;
               hud_cas_y = hud_ca_y+1;
               hud_c_x = pos_x+1;
               hud_c_y = pos_y+1;
               hud_b_x = pos_x;
               hud_b_y = pos_y;
               break;
      case 1 : hud_t_x = pos_x+5;
               hud_t_y = pos_y+3;
               hud_ts_x = hud_t_x-1;
               hud_ts_y = hud_t_y+1;
               hud_ma_x = hud_t_x+27;
               hud_ma_y = hud_t_y+20;
               hud_mas_x = hud_ma_x-1;
               hud_mas_y = hud_ma_y+1;
               hud_ca_x = hud_ma_x-24;
               hud_ca_y = hud_ma_y+13;
               hud_cas_x = hud_ca_x-1;
               hud_cas_y = hud_ca_y+1;
               hud_c_x = pos_x+1;
               hud_c_y = pos_y+1;
               hud_b_x = pos_x;
               hud_b_y = pos_y;
               break;
      case 2 : hud_t_x = pos_x+4;
               hud_t_y = pos_y+59;
               hud_ts_x = hud_t_x+1;
               hud_ts_y = hud_t_y-1;
               hud_ma_x = hud_t_x+7;
               hud_ma_y = hud_t_y-63;
               hud_mas_x = hud_ma_x+1;
               hud_mas_y = hud_ma_y-1;
               hud_ca_x = hud_ma_x+41;
               hud_ca_y = hud_ma_y+15;
               hud_cas_x = hud_ca_x+1;
               hud_cas_y = hud_ca_y-1;
               hud_c_x = pos_x+1;
               hud_c_y = pos_y+1;
               hud_b_x = pos_x;
               hud_b_y = pos_y;
               break;
      case 3 : hud_t_x = pos_x+5;
               hud_t_y = pos_y+59;
               hud_ts_x = hud_t_x+1;
               hud_ts_y = hud_t_y-1;
               hud_ma_x = hud_t_x+27;
               hud_ma_y = hud_t_y-63;
               hud_mas_x = hud_ma_x+1;
               hud_mas_y = hud_ma_y-1;
               hud_ca_x = hud_ma_x-24;
               hud_ca_y = hud_ma_y+15;
               hud_cas_x = hud_ca_x+1;
               hud_cas_y = hud_ca_y-1;
               hud_c_x = pos_x+1;
               hud_c_y = pos_y+1;
               hud_b_x = pos_x;
               hud_b_y = pos_y;
               break;
   }

      DrawCell(0,l_c+TAG+"c"+0 , hud_c_x, hud_c_y, 89, 12, color_cell, HUD_corner);
      DrawCell(0,l_c+TAG+"c"+1 , hud_c_x, hud_c_y+12, 89, 12, color_cell, HUD_corner);
      DrawCell(0,l_c+TAG+"c"+2 , hud_c_x, hud_c_y+24, 89, 12, color_cell, HUD_corner);
      DrawCell(0,l_c+TAG+"c"+3 , hud_c_x, hud_c_y+36, 89, 12, color_cell, HUD_corner);
      DrawCell(0,l_c+TAG+"c"+4 , hud_c_x, hud_c_y+48, 89, 12, color_cell, HUD_corner);
      DrawCell(0,l_c+TAG+"c"+5 , hud_c_x, hud_c_y+60, 89, 12, color_cell, HUD_corner);
      DrawCell(0,l_c+TAG+"c"+6 , hud_c_x, hud_c_y+67, 89, 12, color_cell, HUD_corner);
      
      DrawCell(0,l_c+TAG+"b"+0 , hud_b_x, hud_b_y, 91, 12, color_border, HUD_corner);
      DrawCell(0,l_c+TAG+"b"+1 , hud_b_x, hud_b_y+12, 91, 12, color_border, HUD_corner);
      DrawCell(0,l_c+TAG+"b"+2 , hud_b_x, hud_b_y+24, 91, 12, color_border, HUD_corner);
      DrawCell(0,l_c+TAG+"b"+3 , hud_b_x, hud_b_y+36, 91, 12, color_border, HUD_corner);
      DrawCell(0,l_c+TAG+"b"+4 , hud_b_x, hud_b_y+48, 91, 12, color_border, HUD_corner);
      DrawCell(0,l_c+TAG+"b"+5 , hud_b_x, hud_b_y+60, 91, 12, color_border, HUD_corner);
      DrawCell(0,l_c+TAG+"b"+6 , hud_b_x, hud_b_y+69, 91, 12, color_border, HUD_corner);
}


void draw(bool m, bool s){
   dir[0] = arrow_dn;
   dir[1] = arrow_dn;
   
   mc = color_dn;
   cc = color_dn;
   mcs = color_dn_s;
   ccs = color_dn_s;
   if(m) {
      mc = color_up;
      mcs = color_up_s;
      dir[0] = arrow_up;
   }
   if(s) {
      cc = color_up;
      ccs = color_up_s;
      dir[1] = arrow_up;
   }
   DrawText("b", "TREND", hud_t_x, hud_t_y, color_hd, font, fs_header, HUD_corner);
   DrawText("a", "TREND", hud_ts_x, hud_ts_y, color_hs, font, fs_header, HUD_corner);
   DrawText("b", dir[0], hud_ma_x, hud_ma_y, mc, "WingDings", fs_main, HUD_corner);
   DrawText("a", dir[0], hud_mas_x, hud_mas_y, mcs, "WingDings", fs_main, HUD_corner);
   DrawText("b", dir[1], hud_ca_x, hud_ca_y, cc, "WingDings", fs_cur, HUD_corner);
   DrawText("a", dir[1], hud_cas_x, hud_cas_y, ccs, "WingDings", fs_cur, HUD_corner);
}

